int read_high;
int read_low;
int diff;
const int sensorPin = A0;
const int stepPin = D1;

// Moving Average Filter to Smooth Readings
const int samples = 10;
int readings[samples]; 
int readingIndex = 0;  // Renamed from 'index' to avoid conflicts
long sum = 0;

void setup() {
    pinMode(sensorPin, INPUT);
    pinMode(stepPin, OUTPUT);
    Serial.begin(115200);

    // Initialize readings array
    for (int i = 0; i < samples; i++) {
        readings[i] = 0;
    }
}

void loop() {
    digitalWrite(stepPin, HIGH);
    delayMicroseconds(300);  // Longer delay for stable response
    read_high = analogRead(sensorPin);

    digitalWrite(stepPin, LOW);
    delayMicroseconds(300);
    read_low = analogRead(sensorPin);

    diff = read_high - read_low;

    // Apply Moving Average Filter
    sum = sum - readings[readingIndex] + diff;
    readings[readingIndex] = diff;
    readingIndex = (readingIndex + 1) % samples;  // Correctly update index
    int filtered_value = sum / samples;

    Serial.println(filtered_value);
    delay(500);  // Sampling delay
}
